###############################################################################
### SERVER: SERVICE {{ service["scheme"] }}://{{ service["host"] }}:{{ service["port"] }}
###############################################################################

{%- if service["is_tls"] %}
<VirtualHost *:80>
  ServerName {{ service["host"] }}
  Protocols http/1.1

  Alias /.well-known/acme-challenge/ /var/www/acme-challenge/{{ service["host"] }}/
  <Directory /var/www/acme-challenge/{{ service["host"] }}>
    Options None
    AllowOverride None
    Require all granted
  </Directory>

  <Location /.well-known/acme-challenge/>
    SetHandler None
  </Location>

  <Location />
    Redirect permanent / https://{{ service["host"] }}:{{ service["port"] }}/
  </Location>
</VirtualHost>
{% endif %}

<VirtualHost *:{{ service["port"] }}>
  ServerName {{ service["host"] }}
  {%- if proxy_protocol %}
  RemoteIPProxyProtocol On
  {%- endif %}
  Protocols h2 h2c http/1.1

  {%- if service["is_tls"] %}
  SSLEngine on

  {%- if acme_enabled %}
  SSLCertificateFile    {{ certs_path }}/acme/{{ service["host"] }}.pub
  SSLCertificateKeyFile {{ certs_path }}/acme/{{ service["host"] }}.key
  {%- else %}
  SSLCertificateFile    {{ certs_path }}/static/{{ service["host"] }}.pub
  SSLCertificateKeyFile {{ certs_path }}/static/{{ service["host"] }}.key
  {%- endif %}
  {%- endif %}

  AllowEncodedSlashes NoDecode

  <Location />
    Require all granted
  </Location>

  {%- if upstream_has_tls %}
  SSLProxyEngine on
  SSLProxyVerify none
  SSLProxyCheckPeerCN off
  SSLProxyCheckPeerName off
  SSLProxyCheckPeerExpire off

  ProxyPass / https://{{ proxy_host }}:{{ service["port"] }}/ upgrade=websocket flushpackets=on receivebuffersize=512 nocanon
  ProxyPassReverse / https://{{ proxy_host }}:{{ service["port"] }}/
  {%- else %}
  ProxyPass / http://{{ proxy_host }}:{{ service["port"] }}/ upgrade=websocket flushpackets=on receivebuffersize=512 nocanon
  ProxyPassReverse / http://{{ proxy_host }}:{{ service["port"] }}/
  {%- endif %}

  ProxyRequests off
  ProxyPreserveHost On

  RequestHeader SetIfEmpty X-Correlation-ID "%{UNIQUE_ID}e"
  RequestHeader Append X-Forwarded-For "%{REMOTE_ADDR}s"
</VirtualHost>
